#ifndef _LIVEPATCH_BSC1099306_KVM_H
#define _LIVEPATCH_BSC1099306_KVM_H

#if IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM)

#include <linux/kvm_types.h>

int __livepatch_bsc1099306_kvm_init(void);
void __livepatch_bsc1099306_kvm_cleanup(void);


struct x86_emulate_ctxt;
struct x86_exception;

int klp_kvm_write_guest_virt_system(struct x86_emulate_ctxt *ctxt,
				    gva_t addr, void *val,
				    unsigned int bytes,
				    struct x86_exception *exception);
int klp_x86_emulate_instruction(struct kvm_vcpu *vcpu,
				unsigned long cr2,
				int emulation_type,
				void *insn,
				int insn_len);
int klp_kvm_arch_vcpu_ioctl_run(struct kvm_vcpu *vcpu, struct kvm_run *kvm_run);
void klp_kvm_arch_sched_in(struct kvm_vcpu *vcpu, int cpu);
void klp_kvm_arch_vcpu_free(struct kvm_vcpu *vcpu);
struct kvm_vcpu *klp_kvm_arch_vcpu_create(struct kvm *kvm,
					  unsigned int id);
int klp_kvm_handle_page_fault(struct kvm_vcpu *vcpu, u64 error_code,
			      u64 fault_address, char *insn, int insn_len);

#endif /* IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM) */

#endif /* _LIVEPATCH_BSC1099306_KVM_H */
