/*
 * livepatch_bsc1103098
 *
 * Fix for CVE-2018-5391, bsc#1103098
 *
 *  Upstream commits:
 *  56e2c94f055d ("inet: frag: enforce memory limits earlier")
 *  4672694bd4f1 ("ipv4: frags: handle possible skb truesize change")
 *  0ed4229b08c1 ("ipv6: defrag: drop non-last frags smaller than min mtu")
 *  7969e5c40dfd ("ip: discard IPv4 datagrams with overlapping segments")
 *  385114dec8a4 ("net: modify skb_rbtree_purge to return the truesize of all
 *                 purged skbs.")
 *  fa0f527358bd ("ip: use rb trees for IP frag queue.")
 *  70837ffe3085 ("ipv4: frags: precedence bug in ip_expire()")
 *
 *  SLE12(-SP1) commits:
 *  none yet
 *
 *  SLE12-SP2 and -SP3 commits:
 *  8bde2925ce206adce28b6238d3c3ab6b7df60e5b
 *  5cfee656d3eb7fb372f04e01c893d5184dc3db2c
 *  5b8256ec0665fca693c418bf51e6e8dfec842fee
 *
 *  SLE15 commits:
 *  bba51ae6043bea301aecddab13ce060bed5f1606
 *  d31209ff15ea37c73a99fb8a37f7310a071917d3
 *  232ab4ae2a67c64e987f790bdee0ffb7c3ddabc1
 *  c5cd0491c10810d5e76a1f33139446482dc51538
 *
 *
 *  Copyright (c) 2018 SUSE
 *  Author: Nicolai Stange <nstange@suse.de>
 *
 *  Based on the original Linux kernel code. Other copyrights apply.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "livepatch_bsc1103098.h"

int livepatch_bsc1103098_init(void)
{
	int r;

	r = livepatch_bsc1103098_vmlinux_init();
	if (r)
		return r;

	return livepatch_bsc1103098_nf_defrag_ipv6_init();
}

void livepatch_bsc1103098_cleanup(void)
{
	livepatch_bsc1103098_nf_defrag_ipv6_cleanup();
}
